---
- name: Install jmespath for json queries
  package:
    name: python3-jmespath
    state: present

- name: Trigger request for wrapping token
  uri:
    url: http://10.0.0.2:8080/hostcert/generate.sh?name={{ name }}
    return_content: "yes"
    body_format: json
  register:
    hostcert_response

- name: Store wrapping token response output
  copy:
    dest: /tmp/wrapping_response
    content: "{{ hostcert_response.content }}"

- name: Get vault token from http response
  set_fact:
    wrapping_response: "{{ hostcert_response.content | from_json }}"

- name: Get token from http response
  set_fact:
    wrapping_token: "{{ wrapping_response['token'] }}"

- name: Get certificate using wrapping token
  uri:
    url: "{{ vault_uri }}/v1/sys/wrapping/unwrap"
    method: POST
    body_format: json
    body: '{}'
    return_content: "yes"
    validate_certs: "no"
    headers:
      Authorization: "Bearer {{ wrapping_token }}"
  register:
    unwrapped_cert

- name: Write certificate and intermediate to file
  copy:
    dest: /etc/pki/tls/certs/hostcert.pem
    content: |
      {{ unwrapped_cert['json']['data']['certificate'] }}
      {{ unwrapped_cert['json']['data']['issuing_ca'] }}
    owner: root
    group: root
    mode: "0444"

- name: Write certificate to file
  copy:
    dest: /etc/pki/tls/certs/hostonly.pem
    content: >
      {{ unwrapped_cert['json']['data']['certificate'] }}
    owner: root
    group: root
    mode: "0444"

- name: Write private key to file
  copy:
    dest: /etc/pki/tls/private/hostkey.pem
    content: >
      {{ unwrapped_cert['json']['data']['private_key'] }}
    owner: root
    group: root
    mode: "0444"
